﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using System.Globalization;
using Infragistics.Windows.DataPresenter;
using System.Collections.ObjectModel;
using Infragistics.Windows.Editors;

namespace XamGridFilterDropDown
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();

            ObservableCollection<string> dataSource = new ObservableCollection<string>();
            dataSource.Add("aaa");
            dataSource.Add("BBB");
            dataSource.Add("ccc");
            dataSource.Add("ddd");
            dataSource.Add("eee");
            dataSource.Add("fff");
            dataSource.Add("ggg");
            dataSource.Add("hhh");
            dataSource.Add("iii");
            dataSource.Add("jjj");
            dataSource.Add("kkk");
            dataSource.Add("lll");
            dataSource.Add("mmm");
            dataSource.Add("ooo");
            dataSource.Add("ppp");
            dataSource.Add("qqqqqqqq");
            dataSource.Add("127890");
            dataSource.Add("aaa");
            dataSource.Add("aaa");
            dataSource.Add("wwwwwwwwww wwww");
            dataSource.Add("iiiiiiiiii");
            BalanceGrid.DataSource = dataSource;
        }


        void FilterCellValuePresenter_Loaded(object sender, RoutedEventArgs e)
        {
            FilterCellValuePresenter fcvp = sender as FilterCellValuePresenter;

            (fcvp.Editor as XamComboEditor).DropDownOpened 
                += new EventHandler<RoutedEventArgs>(FilterCellValuePresenter_DropDownOpened);
           

        }

        void FilterCellValuePresenter_DropDownOpened(object sender, RoutedEventArgs e)
        {
            XamComboEditor xamCombo = sender as XamComboEditor;
            ComboBox cb = xamCombo.ComboBox;
            double maxWidth = 0;
            foreach (var s in cb.Items)
            {
                FormattedText ft = new FormattedText(
                            (s as FilterDropDownItem).DisplayText,
                            CultureInfo.CurrentCulture,
                            FlowDirection.LeftToRight,
                            new Typeface(xamCombo.FontFamily.Source),
                            xamCombo.FontSize,
                            Brushes.Black);
                if (ft.Width > maxWidth)
                    maxWidth = ft.Width;

            }
            

           xamCombo.MaxDropDownWidth = maxWidth + 30;
           xamCombo.MinDropDownWidth = maxWidth + 30;
        }

       
    }
}
